program kaefedit;

{$M 16384,0,655360}

uses crt,dos,intuit,graph,drivers;

const titel =' o     Kferstndchen - Editor              UJA Vers. 1.000          TP6    o';
      code:string=' 12345678e#mKM';
      imafile='kaefer.ima';  levelfil='kaefer.l';
      dx=24; dy=24; xmax=24; ymax=16; ox=8; oy=8;
      pal:array[0..15,0..2] of word=
      ((  0,0,0),(47,47,47), (31,31,31),(63,63,63),
       ( 42,  4,  4),( 57, 16, 17),( 63, 29, 31),(  0, 29, 32),
       (  0, 12, 59),( 18, 42, 59),( 20, 61, 38),( 31, 63,  0),
       ( 61, 10, 63),( 52, 39,  0),( 63, 63,  0),( 62, 63, 36));

type feld = array[0..succ(xmax),0..succ(ymax)] of integer;

var ok,ende,fertig           :boolean;
    ch0,ch1                  :char;
    temp,ue                  :string;
    g,mx,my,x,y,level,zeit,ux,uy,select:integer;
    f0,f                     :feld;
    ima           :array[0..28] of image;
    igad          :array[1..10] of Gadget;
    itext1,itext2 :array[1..12] of IntuiText;
    stringinfo    :array[1..3] of StrInfo;
    ibord1,ibord2 :Border;
    xy            :Koords;

{ ------------------------------------------------------------------------ }

procedure setcolors;
var i:integer;
begin
   for i:=0 to 15 do SetRGBPalette(i,pal[i,0],pal[i,1],pal[i,2]);
   for i:=1 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }

procedure getimages;
var i,j,k,anz:integer;
    fh   :file;
begin
assign(fh,imafile);
reset(fh,1);
BlockRead(fh,ima[0],sizeof(Image),anz);
with ima[0] do begin
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
   putimage(0,0,p_data^,normalput);
end;
close(fh);
k:=0;
for i:=0 to 6 do for j:=0 to 3 do begin
   inc(k);
   with ima[k] do begin
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(i*dx,j*dy,i*dx+pred(dx),j*dy+pred(dy),p_data^);
      p_nextimage:=nil;
   end;
end;
end;

{ ------------------------------------------------------------------------ }

procedure initgadgets;
var i,j,k:integer;
begin
   itext1[1].itext:='Lname: ';
   itext1[2].itext:='Level: ';
   itext1[3].itext:=' Zeit: ';
   itext1[4].itext:=' Laden ';
   itext1[5].itext:='Sichern';
   itext1[6].itext:='  Neu  ';
   itext1[7].itext:='  Alt  ';
   itext1[8].itext:='  Quit ';
   for i:=1 to 8 do begin
      with itext1[i] do begin
         x:=5;
         y:=4;
         fpen:=4;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=addr(itext2[i]);
      end;
      with itext2[i] do begin
         x:=pred(itext1[i].x);
         y:=itext1[i].y;
         itext:=itext1[i].itext;
         fpen:=0;
         bpen:=15;
         drmode:=jam1;
         p_nexttext:=nil;
      end;
   end;

   xy[0]:=7; xy[1]:=0;
   xy[2]:=7; xy[3]:=5;
   xy[4]:=2; xy[5]:=5;
   xy[6]:=11; xy[7]:=14;
   xy[8]:=20; xy[9]:=5;

   xy[10]:=13; xy[11]:=5;
   xy[12]:=13; xy[13]:=0;
   xy[14]:=7; xy[15]:=0;


   with ibord1 do begin
      x:=0; y:=0; fpen:=0; bpen:=0; drmode:=jam1; ecken:=8;
      p_ecken:=addr(xy);
      p_nextborder:=addr(ibord2);
   end;
   with ibord2 do begin
      x:=1; y:=1; fpen:=3; bpen:=0; drmode:=jam1; ecken:=8;
      p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;

   for i:=1 to 3 do with stringinfo[i] do begin
      x:=56; y:=4;
      if i=1 then maxlen:=24 else maxlen:=5;
      fpen:=0; bpen:=1;
      case i of
      1: buff:='Ei, wo sind sie denn?';
      2: buff:='01';
      3: buff:='300';
      end;
      ubuff:='';
   end;

   for i:=1 to 10 do with igad[i] do begin
      id:=i;
      case i of
      1:    begin
               x:=12;
               y:=448;
               width:=256;
               height:=16;
               p_loimage:=nil;
            end;
      2..3: begin
               x:=i*112-212;
               y:=464;
               width:=120;
               height:=16;
               p_loimage:=nil;
            end;
      4..8: begin
               x:=i*80-80;
               y:=464;
               width:=72;
               height:=16;
               p_loimage:=nil;
            end;
      9:    begin
               x:=11*dx+ox;
               y:=18*dy+oy;
               width:=14*dx;
               height:=dy;
               p_loimage:=nil;
            end;
      10:    begin
               x:=ox+dx;
               y:=oy+dy;
               width:=xmax*dx;
               height:=ymax*dy;
               p_loimage:=nil;
            end;
      end;
      bpen:=-1;
      if i=1 then bpen:=15;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      if i<9 then p_lointuitext:=addr(itext1[i]) else p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      p_hiimage:=p_loimage;
      if i>3 then gadgettyp:=boolgadget else gadgettyp:=strgadget;
      onoff:=false;
      active:=true;
      if i<4 then p_specialinfo:=addr(stringinfo[i]) else p_specialinfo:=nil;
      if i<10 then p_nextgadget:=addr(igad[succ(i)]) else p_nextgadget:=nil;
   end;
   igad[3].active:=false;
end;

{ ------------------------------------------------------------------- }

procedure buildscreen;
var i,j:integer;
begin
rectfill(0,0,639,479,15);
rectfill(0,16,639,463,2);
setcolor(3); line(0,0,639,0);   line(0,464,639,464); outtextxy(5,4,titel);
setcolor(0); line(0,15,639,15); line(0,479,639,479); outtextxy(4,4,titel);
setcolor(0);
for i:=1 to succ(xmax) do line(ox+i*dx,oy+dy,ox+i*dx,oy+succ(ymax)*dy);
for i:=1 to succ(ymax) do line(ox+dx,oy+i*dy,ox+succ(xmax)*dx,oy+i*dy);
RefreshGadgets(addr(igad[1]));
end;

{ ------------------------------------------------------------------------ }

procedure messi(temp:string);
begin
rectfill(12,432,267,447,2);
setcolor(3); outtextxy(16,436,temp);
end;

procedure markiere(nr:integer);
var x,y:integer;
begin
rectfill(11*dx+ox,17*dy+oy,pred(25*dx+ox),pred(18*dy+oy),2);
DrawBorder((10+nr)*dx+ox,17*dy+oy+6,addr(ibord1));
end;

{ ------------------------------------------------------------------------ }

procedure zeichneelement(x,y,z:integer);
begin
case z of
  0..8: putimage(x*dx+ox,y*dy+oy,ima[20+z].p_data^,normalput);
     9: putimage(x*dx+ox,y*dy+oy,ima[19].p_data^,normalput);
    10: putimage(x*dx+ox,y*dy+oy,ima[17].p_data^,normalput);
    11: putimage(x*dx+ox,y*dy+oy,ima[18].p_data^,normalput);
    12: putimage(x*dx+ox,y*dy+oy,ima[1].p_data^,normalput);
    13..16: putimage(x*dx+ox,y*dy+oy,ima[9].p_data^,normalput);
end;
setcolor(0);
line(x*dx+ox,y*dy+oy+pred(dy),x*dx+ox+pred(dx),y*dy+oy+pred(dy));
line(x*dx+ox+pred(dx),y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy));
end;

procedure initlevel;
var i,j:integer;
begin
   for i:=1 to xmax do for j:=1 to ymax do f[i,j]:=10;
   for i:=2 to pred(xmax) do for j:=2 to pred(ymax) do f[i,j]:=0;
   for i:=1 to xmax do for j:=1 to ymax do zeichneelement(i,j,f[i,j]);
   for i:=0 to 13 do zeichneelement(i+11,18,i);
   messi('leeres Level');
end;


procedure speichern(var f1:feld; var zeit,level:integer; var ue:string);
var fh:text;
    temp:string;
    i,j:integer;
begin
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
   assign(fh,temp);
   rewrite(fh);
   writeln(fh,ue);
   writeln(fh,zeit);
   for j:=1 to ymax do begin
      temp:='';
      for i:=1 to xmax do temp:=temp+code[f1[i,j]];
      writeln(fh,temp);
   end;
   close(fh);
   messi('Level gespeichert');
end;

{ ------------------------------------------------------------------------ }

procedure laden(level:integer);
var fh:text;
    temp:string;
    i,j:integer;
begin
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
   assign(fh,temp);
   reset(fh);
   readln(fh,stringinfo[1].buff);
   for j:=1 to ymax do begin
      readln(fh,temp);
      for i:=1 to xmax do f[i,j]:=pos(temp[i],code)-1;
   end;
   close(fh);

   for i:=1 to xmax do for j:=1 to ymax do zeichneelement(i,j,f[i,j]);
   zeit:=0;
   str(level:2,temp);
   stringinfo[2].buff:=temp;
   str(zeit:3,temp);
   stringinfo[3].buff:=temp;
   RefreshGadgets(addr(igad[1]));
   messi('Datei geladen');
end;



procedure sichern(level:integer);
var fh:text;
    temp:string;
    i,j:integer;
begin
   str(level:2,temp);
   if temp[1]=' ' then temp[1]:='0';
   temp:=levelfil+temp;
   assign(fh,temp);
   rewrite(fh);
   writeln(fh,stringinfo[1].buff);
   for j:=1 to ymax do begin
      temp:='';
      for i:=1 to xmax do temp:=temp+code[f[i,j]+1];
      writeln(fh,temp);
   end;
   close(fh);
   messi('Datei geschrieben');
   RefreshGadgets(addr(igad[1]));
end;


{ ====================================================================== }

begin
   initscreen(ok);
   if ok then begin
      setcolors;
      getimages;
      initgadgets;
      buildscreen;
      initlevel;
      f0:=f;
      level:=1;
      zeit:=300;
      ende:=false;
      select:=1;
      markiere(select);
      while not ende do begin
         showmouse;
         delay(50);
         g:=-1;
         if keypressed then begin
            ch0:=readkey;
            case ch0 of
            #27,'Q','q': g:=8;
            end;
         end else getgadget(addr(igad[1]),g,mx,my);
         hidemouse;
         case g of
         1..3: begin
                  if g>1 then val(stringinfo[g].buff,ux,mx); 
                  getstring(igad[g]);
                  if g>1 then begin
                     val(stringinfo[g].buff,mx,my);
                     if my<>0 then mx:=ux;
                     if g=2 then ux:=2 else ux:=3;
                     str(mx:ux,stringinfo[g].buff);
                  end;
                  DrawGadget(addr(igad[g]));
               end;
         4:    begin
                  val(stringinfo[2].buff,mx,my);
                  laden(mx);
                  f0:=f;
               end;
         5:    begin
                  val(stringinfo[2].buff,mx,my);
                  sichern(mx);
               end;
         6:    initlevel;
         7:    begin
                  f:=f0;
                  for mx:=1 to xmax do for my:=1 to ymax do
                  zeichneelement(mx,my,f[mx,my]);
                  messi('Level wiederhergestellt');
               end;
         8:    ende:=true;
         9:    begin
                  select:=(mx-ox) div dx;
                  select:=select-10;
                  markiere(select);
               end;
         10:   begin
                  mx:=(mx-ox) div dx;
                  my:=(my-oy) div dy;
                  f[mx,my]:=select-1;
                  zeichneelement(mx,my,f[mx,my]);
               end;
         end;

      end;
   end;
   textmode(3);
end.

